/*
 * This file is generated by jOOQ.
 */
package be.lghs.accounting.model.tables.records;


import be.lghs.accounting.model.tables.Movements;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.UUID;

import javax.annotation.processing.Generated;

import org.jooq.Field;
import org.jooq.Record1;
import org.jooq.Record10;
import org.jooq.Row10;
import org.jooq.impl.UpdatableRecordImpl;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "https://www.jooq.org",
        "jOOQ version:3.14.9",
        "schema version:accounting_0010"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class MovementsRecord extends UpdatableRecordImpl<MovementsRecord> implements Record10<UUID, BigDecimal, LocalDate, UUID, UUID, Integer, String, String, String, UUID> {

    private static final long serialVersionUID = 1L;

    /**
     * Setter for <code>accounting.movements.id</code>.
     */
    public void setId(UUID value) {
        set(0, value);
    }

    /**
     * Getter for <code>accounting.movements.id</code>.
     */
    public UUID getId() {
        return (UUID) get(0);
    }

    /**
     * Setter for <code>accounting.movements.amount</code>.
     */
    public void setAmount(BigDecimal value) {
        set(1, value);
    }

    /**
     * Getter for <code>accounting.movements.amount</code>.
     */
    public BigDecimal getAmount() {
        return (BigDecimal) get(1);
    }

    /**
     * Setter for <code>accounting.movements.entry_date</code>.
     */
    public void setEntryDate(LocalDate value) {
        set(2, value);
    }

    /**
     * Getter for <code>accounting.movements.entry_date</code>.
     */
    public LocalDate getEntryDate() {
        return (LocalDate) get(2);
    }

    /**
     * Setter for <code>accounting.movements.account_id</code>.
     */
    public void setAccountId(UUID value) {
        set(3, value);
    }

    /**
     * Getter for <code>accounting.movements.account_id</code>.
     */
    public UUID getAccountId() {
        return (UUID) get(3);
    }

    /**
     * Setter for <code>accounting.movements.coda_id</code>.
     */
    public void setCodaId(UUID value) {
        set(4, value);
    }

    /**
     * Getter for <code>accounting.movements.coda_id</code>.
     */
    public UUID getCodaId() {
        return (UUID) get(4);
    }

    /**
     * Setter for <code>accounting.movements.coda_sequence_number</code>.
     */
    public void setCodaSequenceNumber(Integer value) {
        set(5, value);
    }

    /**
     * Getter for <code>accounting.movements.coda_sequence_number</code>.
     */
    public Integer getCodaSequenceNumber() {
        return (Integer) get(5);
    }

    /**
     * Setter for <code>accounting.movements.counter_party_account_number</code>.
     */
    public void setCounterPartyAccountNumber(String value) {
        set(6, value);
    }

    /**
     * Getter for <code>accounting.movements.counter_party_account_number</code>.
     */
    public String getCounterPartyAccountNumber() {
        return (String) get(6);
    }

    /**
     * Setter for <code>accounting.movements.counter_party_name</code>.
     */
    public void setCounterPartyName(String value) {
        set(7, value);
    }

    /**
     * Getter for <code>accounting.movements.counter_party_name</code>.
     */
    public String getCounterPartyName() {
        return (String) get(7);
    }

    /**
     * Setter for <code>accounting.movements.communication</code>.
     */
    public void setCommunication(String value) {
        set(8, value);
    }

    /**
     * Getter for <code>accounting.movements.communication</code>.
     */
    public String getCommunication() {
        return (String) get(8);
    }

    /**
     * Setter for <code>accounting.movements.category_id</code>.
     */
    public void setCategoryId(UUID value) {
        set(9, value);
    }

    /**
     * Getter for <code>accounting.movements.category_id</code>.
     */
    public UUID getCategoryId() {
        return (UUID) get(9);
    }

    // -------------------------------------------------------------------------
    // Primary key information
    // -------------------------------------------------------------------------

    @Override
    public Record1<UUID> key() {
        return (Record1) super.key();
    }

    // -------------------------------------------------------------------------
    // Record10 type implementation
    // -------------------------------------------------------------------------

    @Override
    public Row10<UUID, BigDecimal, LocalDate, UUID, UUID, Integer, String, String, String, UUID> fieldsRow() {
        return (Row10) super.fieldsRow();
    }

    @Override
    public Row10<UUID, BigDecimal, LocalDate, UUID, UUID, Integer, String, String, String, UUID> valuesRow() {
        return (Row10) super.valuesRow();
    }

    @Override
    public Field<UUID> field1() {
        return Movements.MOVEMENTS.ID;
    }

    @Override
    public Field<BigDecimal> field2() {
        return Movements.MOVEMENTS.AMOUNT;
    }

    @Override
    public Field<LocalDate> field3() {
        return Movements.MOVEMENTS.ENTRY_DATE;
    }

    @Override
    public Field<UUID> field4() {
        return Movements.MOVEMENTS.ACCOUNT_ID;
    }

    @Override
    public Field<UUID> field5() {
        return Movements.MOVEMENTS.CODA_ID;
    }

    @Override
    public Field<Integer> field6() {
        return Movements.MOVEMENTS.CODA_SEQUENCE_NUMBER;
    }

    @Override
    public Field<String> field7() {
        return Movements.MOVEMENTS.COUNTER_PARTY_ACCOUNT_NUMBER;
    }

    @Override
    public Field<String> field8() {
        return Movements.MOVEMENTS.COUNTER_PARTY_NAME;
    }

    @Override
    public Field<String> field9() {
        return Movements.MOVEMENTS.COMMUNICATION;
    }

    @Override
    public Field<UUID> field10() {
        return Movements.MOVEMENTS.CATEGORY_ID;
    }

    @Override
    public UUID component1() {
        return getId();
    }

    @Override
    public BigDecimal component2() {
        return getAmount();
    }

    @Override
    public LocalDate component3() {
        return getEntryDate();
    }

    @Override
    public UUID component4() {
        return getAccountId();
    }

    @Override
    public UUID component5() {
        return getCodaId();
    }

    @Override
    public Integer component6() {
        return getCodaSequenceNumber();
    }

    @Override
    public String component7() {
        return getCounterPartyAccountNumber();
    }

    @Override
    public String component8() {
        return getCounterPartyName();
    }

    @Override
    public String component9() {
        return getCommunication();
    }

    @Override
    public UUID component10() {
        return getCategoryId();
    }

    @Override
    public UUID value1() {
        return getId();
    }

    @Override
    public BigDecimal value2() {
        return getAmount();
    }

    @Override
    public LocalDate value3() {
        return getEntryDate();
    }

    @Override
    public UUID value4() {
        return getAccountId();
    }

    @Override
    public UUID value5() {
        return getCodaId();
    }

    @Override
    public Integer value6() {
        return getCodaSequenceNumber();
    }

    @Override
    public String value7() {
        return getCounterPartyAccountNumber();
    }

    @Override
    public String value8() {
        return getCounterPartyName();
    }

    @Override
    public String value9() {
        return getCommunication();
    }

    @Override
    public UUID value10() {
        return getCategoryId();
    }

    @Override
    public MovementsRecord value1(UUID value) {
        setId(value);
        return this;
    }

    @Override
    public MovementsRecord value2(BigDecimal value) {
        setAmount(value);
        return this;
    }

    @Override
    public MovementsRecord value3(LocalDate value) {
        setEntryDate(value);
        return this;
    }

    @Override
    public MovementsRecord value4(UUID value) {
        setAccountId(value);
        return this;
    }

    @Override
    public MovementsRecord value5(UUID value) {
        setCodaId(value);
        return this;
    }

    @Override
    public MovementsRecord value6(Integer value) {
        setCodaSequenceNumber(value);
        return this;
    }

    @Override
    public MovementsRecord value7(String value) {
        setCounterPartyAccountNumber(value);
        return this;
    }

    @Override
    public MovementsRecord value8(String value) {
        setCounterPartyName(value);
        return this;
    }

    @Override
    public MovementsRecord value9(String value) {
        setCommunication(value);
        return this;
    }

    @Override
    public MovementsRecord value10(UUID value) {
        setCategoryId(value);
        return this;
    }

    @Override
    public MovementsRecord values(UUID value1, BigDecimal value2, LocalDate value3, UUID value4, UUID value5, Integer value6, String value7, String value8, String value9, UUID value10) {
        value1(value1);
        value2(value2);
        value3(value3);
        value4(value4);
        value5(value5);
        value6(value6);
        value7(value7);
        value8(value8);
        value9(value9);
        value10(value10);
        return this;
    }

    // -------------------------------------------------------------------------
    // Constructors
    // -------------------------------------------------------------------------

    /**
     * Create a detached MovementsRecord
     */
    public MovementsRecord() {
        super(Movements.MOVEMENTS);
    }

    /**
     * Create a detached, initialised MovementsRecord
     */
    public MovementsRecord(UUID id, BigDecimal amount, LocalDate entryDate, UUID accountId, UUID codaId, Integer codaSequenceNumber, String counterPartyAccountNumber, String counterPartyName, String communication, UUID categoryId) {
        super(Movements.MOVEMENTS);

        setId(id);
        setAmount(amount);
        setEntryDate(entryDate);
        setAccountId(accountId);
        setCodaId(codaId);
        setCodaSequenceNumber(codaSequenceNumber);
        setCounterPartyAccountNumber(counterPartyAccountNumber);
        setCounterPartyName(counterPartyName);
        setCommunication(communication);
        setCategoryId(categoryId);
    }
}
